//
// Copyright (c) ZeroC, Inc. All rights reserved.
//
//
// Ice version 3.7.10
//
// <auto-generated>
//
// Generated from file `Locator.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

/* eslint-disable */
/* jshint ignore: start */

/* slice2js browser-bundle-skip */
const _ModuleRegistry = require("../Ice/ModuleRegistry").Ice._ModuleRegistry;
require("../Ice/Object");
require("../Ice/Value");
require("../Ice/ObjectPrx");
require("../Ice/Operation");
require("../Ice/Exception");
require("../Ice/Long");
require("../Ice/HashMap");
require("../Ice/HashUtil");
require("../Ice/ArrayUtil");
require("../Ice/StreamHelpers");
require("../Ice/Identity");
require("../Ice/Process");
const Ice = _ModuleRegistry.module("Ice");

const Slice = Ice.Slice;
/* slice2js browser-bundle-skip-end */

/**
 * This exception is raised if an adapter cannot be found.
 *
 **/
Ice.AdapterNotFoundException = class extends Ice.UserException
{
    constructor(_cause = "")
    {
        super(_cause);
    }

    static get _parent()
    {
        return Ice.UserException;
    }

    static get _id()
    {
        return "::Ice::AdapterNotFoundException";
    }

    _mostDerivedType()
    {
        return Ice.AdapterNotFoundException;
    }
};

/**
 * This exception is raised if the replica group provided by the
 * server is invalid.
 *
 **/
Ice.InvalidReplicaGroupIdException = class extends Ice.UserException
{
    constructor(_cause = "")
    {
        super(_cause);
    }

    static get _parent()
    {
        return Ice.UserException;
    }

    static get _id()
    {
        return "::Ice::InvalidReplicaGroupIdException";
    }

    _mostDerivedType()
    {
        return Ice.InvalidReplicaGroupIdException;
    }
};

/**
 * This exception is raised if a server tries to set endpoints for
 * an adapter that is already active.
 *
 **/
Ice.AdapterAlreadyActiveException = class extends Ice.UserException
{
    constructor(_cause = "")
    {
        super(_cause);
    }

    static get _parent()
    {
        return Ice.UserException;
    }

    static get _id()
    {
        return "::Ice::AdapterAlreadyActiveException";
    }

    _mostDerivedType()
    {
        return Ice.AdapterAlreadyActiveException;
    }
};

/**
 * This exception is raised if an object cannot be found.
 *
 **/
Ice.ObjectNotFoundException = class extends Ice.UserException
{
    constructor(_cause = "")
    {
        super(_cause);
    }

    static get _parent()
    {
        return Ice.UserException;
    }

    static get _id()
    {
        return "::Ice::ObjectNotFoundException";
    }

    _mostDerivedType()
    {
        return Ice.ObjectNotFoundException;
    }
};

/**
 * This exception is raised if a server cannot be found.
 *
 **/
Ice.ServerNotFoundException = class extends Ice.UserException
{
    constructor(_cause = "")
    {
        super(_cause);
    }

    static get _parent()
    {
        return Ice.UserException;
    }

    static get _id()
    {
        return "::Ice::ServerNotFoundException";
    }

    _mostDerivedType()
    {
        return Ice.ServerNotFoundException;
    }
};

const iceC_Ice_Locator_ids = [
    "::Ice::Locator",
    "::Ice::Object"
];

/**
 * The Ice locator interface. This interface is used by clients to
 * lookup adapters and objects. It is also used by servers to get the
 * locator registry proxy.
 *
 * <p class="Note">The {@link Locator} interface is intended to be used by
 * Ice internals and by locator implementations. Regular user code
 * should not attempt to use any functionality of this interface
 * directly.
 *
 **/
Ice.Locator = class extends Ice.Object
{
};

Ice.LocatorPrx = class extends Ice.ObjectPrx
{
};

Slice.defineOperations(Ice.Locator, Ice.LocatorPrx, iceC_Ice_Locator_ids, 0,
{
    "findObjectById": [, 2, 1, , [9], [[Ice.Identity]], ,
    [
        Ice.ObjectNotFoundException
    ], , ],
    "findAdapterById": [, 2, 1, , [9], [[7]], ,
    [
        Ice.AdapterNotFoundException
    ], , ],
    "getRegistry": [, 2, 1, , ["Ice.LocatorRegistryPrx"], , , , , ]
});

const iceC_Ice_LocatorRegistry_ids = [
    "::Ice::LocatorRegistry",
    "::Ice::Object"
];

/**
 * The Ice locator registry interface. This interface is used by
 * servers to register adapter endpoints with the locator.
 *
 * <p class="Note"> The {@link LocatorRegistry} interface is intended to be used
 * by Ice internals and by locator implementations. Regular user
 * code should not attempt to use any functionality of this interface
 * directly.
 *
 **/
Ice.LocatorRegistry = class extends Ice.Object
{
};

Ice.LocatorRegistryPrx = class extends Ice.ObjectPrx
{
};

Slice.defineOperations(Ice.LocatorRegistry, Ice.LocatorRegistryPrx, iceC_Ice_LocatorRegistry_ids, 0,
{
    "setAdapterDirectProxy": [, 2, 2, , , [[7], [9]], ,
    [
        Ice.AdapterAlreadyActiveException,
        Ice.AdapterNotFoundException
    ], , ],
    "setReplicatedAdapterDirectProxy": [, 2, 2, , , [[7], [7], [9]], ,
    [
        Ice.AdapterAlreadyActiveException,
        Ice.AdapterNotFoundException,
        Ice.InvalidReplicaGroupIdException
    ], , ],
    "setServerProcessProxy": [, 2, 2, , , [[7], ["Ice.ProcessPrx"]], ,
    [
        Ice.ServerNotFoundException
    ], , ]
});

const iceC_Ice_LocatorFinder_ids = [
    "::Ice::LocatorFinder",
    "::Ice::Object"
];

/**
 * This inferface should be implemented by services implementing the
 * Ice::Locator interface. It should be advertised through an Ice
 * object with the identity `Ice/LocatorFinder'. This allows clients
 * to retrieve the locator proxy with just the endpoint information of
 * the service.
 *
 **/
Ice.LocatorFinder = class extends Ice.Object
{
};

Ice.LocatorFinderPrx = class extends Ice.ObjectPrx
{
};

Slice.defineOperations(Ice.LocatorFinder, Ice.LocatorFinderPrx, iceC_Ice_LocatorFinder_ids, 0,
{
    "getLocator": [, , , , ["Ice.LocatorPrx"], , , , , ]
});
/* slice2js browser-bundle-skip */
exports.Ice = Ice;
/* slice2js browser-bundle-skip-end */
