"use strict";

//
// Copyright (c) ZeroC, Inc. All rights reserved.
//
var Ice = require("../Ice/LocalException").Ice; //
// Local aliases.
//


var UnexpectedObjectException = Ice.UnexpectedObjectException;
var MemoryLimitException = Ice.MemoryLimitException; //
// Exception utilities
//

Ice.ExUtil = {
  throwUOE: function throwUOE(expectedType, v) {
    var type = v.ice_id();
    throw new UnexpectedObjectException("expected element of type `" + expectedType + "' but received `" + type + "'", type, expectedType);
  },
  throwMemoryLimitException: function throwMemoryLimitException(requested, maximum) {
    throw new MemoryLimitException("requested " + requested + " bytes, maximum allowed is " + maximum + " bytes (see Ice.MessageSizeMax)");
  }
};
module.exports.Ice = Ice;