"use strict";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

//
// Copyright (c) ZeroC, Inc. All rights reserved.
//
var Ice = require("../Ice/ModuleRegistry").Ice;

require("../Ice/Debug");

require("../Ice/LocalException");

require("../Ice/ProcessLogger");

require("../Ice/ProcessLogger");

require("../Ice/PropertyNames");

require("../Ice/StringUtil");

var StringUtil = Ice.StringUtil;
var PropertyNames = Ice.PropertyNames;
var Debug = Ice.Debug;
var getProcessLogger = Ice.getProcessLogger;
var InitializationException = Ice.InitializationException;
var ParseStateKey = 0;
var ParseStateValue = 1; //
// Ice.Properties
//

var Properties = /*#__PURE__*/function () {
  function Properties(args, defaults) {
    _classCallCheck(this, Properties);

    this._properties = new Map();

    if (defaults !== undefined && defaults !== null) {
      //
      // NOTE: we can't just do a shallow copy of the map as the map values
      // would otherwise be shared between the two PropertiesI object.
      //
      var _iterator = _createForOfIteratorHelper(defaults._properties),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = _slicedToArray(_step.value, 2),
              key = _step$value[0],
              property = _step$value[1];

          this._properties.set(key, {
            value: property.value,
            used: false
          });
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }

    if (args !== undefined && args !== null) {
      var v = this.parseIceCommandLineOptions(args);
      args.length = 0;

      for (var i = 0; i < v.length; ++i) {
        args.push(v[i]);
      }
    }
  }

  _createClass(Properties, [{
    key: "getProperty",
    value: function getProperty(key) {
      return this.getPropertyWithDefault(key, "");
    }
  }, {
    key: "getPropertyWithDefault",
    value: function getPropertyWithDefault(key, value) {
      var pv = this._properties.get(key);

      if (pv !== undefined) {
        pv.used = true;
        return pv.value;
      } else {
        return value;
      }
    }
  }, {
    key: "getPropertyAsInt",
    value: function getPropertyAsInt(key) {
      return this.getPropertyAsIntWithDefault(key, 0);
    }
  }, {
    key: "getPropertyAsIntWithDefault",
    value: function getPropertyAsIntWithDefault(key, value) {
      var pv = this._properties.get(key);

      if (pv !== undefined) {
        pv.used = true;
        return parseInt(pv.value);
      } else {
        return value;
      }
    }
  }, {
    key: "getPropertyAsList",
    value: function getPropertyAsList(key) {
      return this.getPropertyAsListWithDefault(key, 0);
    }
  }, {
    key: "getPropertyAsListWithDefault",
    value: function getPropertyAsListWithDefault(key, value) {
      if (value === undefined || value === null) {
        value = [];
      }

      var pv = this._properties.get(key);

      if (pv !== undefined) {
        pv.used = true;
        var result = StringUtil.splitString(pv.value, ", \t\r\n");

        if (result === null) {
          getProcessLogger().warning("mismatched quotes in property " + key + "'s value, returning default value");
          return value;
        }

        if (result.length === 0) {
          result = value;
        }

        return result;
      } else {
        return value;
      }
    }
  }, {
    key: "getPropertiesForPrefix",
    value: function getPropertiesForPrefix() {
      var prefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
      var result = new Map();

      this._properties.forEach(function (property, key) {
        if (key.indexOf(prefix) === 0) {
          property.used = true;
          result.set(key, property.value);
        }
      });

      return result;
    }
  }, {
    key: "setProperty",
    value: function setProperty() {
      var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

      //
      // Trim whitespace
      //
      if (key !== null) {
        key = key.trim();
      } //
      // Check if the property is legal.
      //


      var logger = getProcessLogger();

      if (key === null || key.length === 0) {
        throw new InitializationException("Attempt to set property with empty key");
      }

      var dotPos = key.indexOf(".");

      if (dotPos !== -1) {
        var prefix = key.substr(0, dotPos);

        for (var i = 0; i < PropertyNames.validProps.length; ++i) {
          var pattern = PropertyNames.validProps[i][0].pattern;
          dotPos = pattern.indexOf("."); //
          // Each top level prefix describes a non-empty namespace. Having a string without a
          // prefix followed by a dot is an error.
          //

          Debug.assert(dotPos != -1);

          if (pattern.substring(0, dotPos - 1) != prefix) {
            continue;
          }

          var found = false;
          var mismatchCase = false;
          var otherKey = void 0;

          for (var j = 0; j < PropertyNames.validProps[i][j].length && !found; ++j) {
            pattern = PropertyNames.validProps[i][j].pattern();
            var pComp = new RegExp(pattern);
            found = pComp.test(key);

            if (found && PropertyNames.validProps[i][j].deprecated) {
              logger.warning("deprecated property: " + key);

              if (PropertyNames.validProps[i][j].deprecatedBy !== null) {
                key = PropertyNames.validProps[i][j].deprecatedBy;
              }
            }

            if (found) {
              break;
            } else {
              pComp = new RegExp(pattern.toUpperCase());
              found = pComp.test(key.toUpperCase());

              if (found) {
                mismatchCase = true;
                otherKey = pattern.substr(2);
                otherKey = otherKey.substr(0, otherKey.length - 1);
                otherKey = otherKey.replace(/\\/g, "");
                break;
              }
            }
          }

          if (!found) {
            logger.warning("unknown property: " + key);
          } else if (mismatchCase) {
            logger.warning("unknown property: `" + key + "'; did you mean `" + otherKey + "'");
          }
        }
      } //
      // Set or clear the property.
      //


      if (value !== null && value.length > 0) {
        var pv = this._properties.get(key);

        if (pv !== undefined) {
          pv.value = value;
        } else {
          this._properties.set(key, {
            value: value,
            used: false
          });
        }
      } else {
        this._properties.delete(key);
      }
    }
  }, {
    key: "getCommandLineOptions",
    value: function getCommandLineOptions() {
      var result = [];

      this._properties.forEach(function (property, key) {
        result.push("--" + key + "=" + property.value);
      });

      return result;
    }
  }, {
    key: "parseCommandLineOptions",
    value: function parseCommandLineOptions(pfx, options) {
      var _this = this;

      if (pfx.length > 0 && pfx.charAt(pfx.length - 1) != ".") {
        pfx += ".";
      }

      pfx = "--" + pfx;
      var result = [];
      options.forEach(function (opt) {
        if (opt.indexOf(pfx) === 0) {
          if (opt.indexOf('=') === -1) {
            opt += "=1";
          }

          _this.parseLine(opt.substring(2));
        } else {
          result.push(opt);
        }
      });
      return result;
    }
  }, {
    key: "parseIceCommandLineOptions",
    value: function parseIceCommandLineOptions(options) {
      var args = options.slice();

      for (var i = 0; i < PropertyNames.clPropNames.length; ++i) {
        args = this.parseCommandLineOptions(PropertyNames.clPropNames[i], args);
      }

      return args;
    }
  }, {
    key: "parse",
    value: function parse(data) {
      var _this2 = this;

      data.match(/[^\r\n]+/g).forEach(function (line) {
        return _this2.parseLine(line);
      });
    }
  }, {
    key: "parseLine",
    value: function parseLine(line) {
      var key = "";
      var value = "";
      var state = ParseStateKey;
      var whitespace = "";
      var escapedspace = "";
      var finished = false;

      for (var i = 0; i < line.length; ++i) {
        var c = line.charAt(i);

        switch (state) {
          case ParseStateKey:
            {
              switch (c) {
                case '\\':
                  if (i < line.length - 1) {
                    c = line.charAt(++i);

                    switch (c) {
                      case '\\':
                      case '#':
                      case '=':
                        key += whitespace;
                        whitespace = "";
                        key += c;
                        break;

                      case ' ':
                        if (key.length !== 0) {
                          whitespace += c;
                        }

                        break;

                      default:
                        key += whitespace;
                        whitespace = "";
                        key += '\\';
                        key += c;
                        break;
                    }
                  } else {
                    key += whitespace;
                    key += c;
                  }

                  break;

                case ' ':
                case '\t':
                case '\r':
                case '\n':
                  if (key.length !== 0) {
                    whitespace += c;
                  }

                  break;

                case '=':
                  whitespace = "";
                  state = ParseStateValue;
                  break;

                case '#':
                  finished = true;
                  break;

                default:
                  key += whitespace;
                  whitespace = "";
                  key += c;
                  break;
              }

              break;
            }

          case ParseStateValue:
            {
              switch (c) {
                case '\\':
                  if (i < line.length - 1) {
                    c = line.charAt(++i);

                    switch (c) {
                      case '\\':
                      case '#':
                      case '=':
                        value += value.length === 0 ? escapedspace : whitespace;
                        whitespace = "";
                        escapedspace = "";
                        value += c;
                        break;

                      case ' ':
                        whitespace += c;
                        escapedspace += c;
                        break;

                      default:
                        value += value.length === 0 ? escapedspace : whitespace;
                        whitespace = "";
                        escapedspace = "";
                        value += '\\';
                        value += c;
                        break;
                    }
                  } else {
                    value += value.length === 0 ? escapedspace : whitespace;
                    value += c;
                  }

                  break;

                case ' ':
                case '\t':
                case '\r':
                case '\n':
                  if (value.length !== 0) {
                    whitespace += c;
                  }

                  break;

                case '#':
                  finished = true;
                  break;

                default:
                  value += value.length === 0 ? escapedspace : whitespace;
                  whitespace = "";
                  escapedspace = "";
                  value += c;
                  break;
              }

              break;
            }

          default:
            {
              Debug.assert(false);
              break;
            }
        }

        if (finished) {
          break;
        }
      }

      value += escapedspace;

      if (state === ParseStateKey && key.length !== 0 || state == ParseStateValue && key.length === 0) {
        getProcessLogger().warning("invalid config file entry: \"" + line + "\"");
        return;
      } else if (key.length === 0) {
        return;
      }

      this.setProperty(key, value);
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Properties(null, this);
    }
  }, {
    key: "getUnusedProperties",
    value: function getUnusedProperties() {
      var unused = [];

      this._properties.forEach(function (property, key) {
        if (!property.used) {
          unused.push(key);
        }
      });

      return unused;
    }
  }], [{
    key: "createProperties",
    value: function createProperties(args, defaults) {
      return new Properties(args, defaults);
    }
  }]);

  return Properties;
}();

Ice.Properties = Properties;
module.exports.Ice = Ice;